<?php 
use SwagPaymentEps\Components\EpsPayment\PaymentResponse;
use SwagPaymentEps\Components\EpsPayment\EpsPaymentService;
use Shopware\Components\CSRFWhitelistAware;

include(dirname(dirname(__DIR__)).'/vendor/autoload.php');
use at\externet\eps_bank_transfer;

class Shopware_Controllers_Frontend_Confirm extends Shopware_Controllers_Frontend_Payment implements CSRFWhitelistAware
{

	public function getWhitelistedCSRFActions()
    {
        return [
            'index'
        ];
    }

    public function indexAction()
    {

    	$soCommunicator = new eps_bank_transfer\SoCommunicator();

        $soCommunicator->HandleConfirmationUrl(
            [$this, 'paymentConfirmationCallback'],
              null,
              'php://input',        
              'php://output'        
            );
        die();
    }
   
    public function paymentConfirmationCallback($plainXml, $bankConfirmationDetails) 
    {
        $orderNumber  = $bankConfirmationDetails->GetRemittanceIdentifier();
        file_put_contents($file,$orderNumber);

        if ($bankConfirmationDetails->GetStatusCode() == 'OK')
        {
            $sql = "UPDATE s_order SET status=2, cleared=12 WHERE ordernumber=$orderNumber";
            Shopware()->Db()->executeUpdate($sql);
        }
        elseif ($bankConfirmationDetails->GetStatusCode() == 'NOK') 
        {
            $sql = "UPDATE s_order SET status=4, cleared=0 WHERE ordernumber=$orderNumber";
            Shopware()->Db()->executeUpdate($sql);
        }
    
      return true; 
        
    }
}