<?php

use SwagPaymentEps\Components\EpsPayment\PaymentResponse;
use SwagPaymentEps\Components\EpsPayment\EpsPaymentService;

require_once('custom/plugins/SwagPaymentEps/vendor/autoload.php');
use at\externet\eps_bank_transfer;

class Shopware_Controllers_Frontend_PaymentEps extends Shopware_Controllers_Frontend_Payment
{
    const PAYMENTSTATUSPAID = 17;
    public function IndexAction()
    {
        /* Get data payment admin config  PIN, IBAN, USER-ID ....*/
        $pluginConfig = $this->get('shopware.plugin.config_reader')->getByPluginName('SwagPaymentEps');
        $userID       = $pluginConfig['userid'];
        $pin          = $pluginConfig['pin'];
        $bic          = $pluginConfig['bic'];
        $iban         = $pluginConfig['iban'];
        $test         = $pluginConfig['test'];
        
        /* Get order ID */
        $user_id  = Shopware()->Session()->sUserId;      
        $order_id1 = Shopware()->Db()->fetchOne("SELECT id FROM s_order WHERE userID=$user_id order by ordertime DESC");
        $order_id = intval($order_id1);
    
        $user = $this->getUser();
        $firstname =  $user["billingaddress"]["firstname"];
        $lastname  =  $user["billingaddress"]["lastname"];
        $fullName = $firstname." ".$lastname;
    
        $orderTotal = $this->getAmount()*100; //Order amount
        
        /* Get order items */
        $sOrder = $this->container->get('session')->offsetGet('sOrderVariables');
        $items = $sOrder["sBasket"]["content"];
             
        /* Save order in database */
        $this->saveOrder($order_id, 1, self::PAYMENTSTATUSPAID);
      
        if($test == TRUE)
        {
            $targetUrl = 'https://routing.eps.or.at/appl/epsSO-test/transinit/eps/v2_5';
        }
        else 
        {
            $targetUrl = 'https://routing.eps.or.at/appl/epsSO/transinit/eps/v2_5';
        }
    
        /* Greška na API-ju ako nema http u linku */
		$protocol = ((!empty($_SERVER['HTTPS']) && $_SERVER['HTTPS'] != 'off') || $_SERVER['SERVER_PORT'] == 443) ? "https://" : "http://";
		$base_url = $protocol.$_SERVER['HTTP_HOST'].substr($_SERVER['REQUEST_URI'], 0, strrpos($_SERVER['REQUEST_URI'], '/') + 1);
		$orderNumber = $this->getOrderNumber();
        
        $responseUrl = $base_url.'/frontend/Confirm';
        $successUrl  = $base_url.'/frontend/success?order_id='.$order_id;
        $failUrl     = $base_url.'/frontend/fail?order_id='.$order_id; 
  
        
        $transferMsgDetails = new eps_bank_transfer\TransferMsgDetails(
            $responseUrl,
            $successUrl,
            $failUrl
        );
         
        $transferInitiatorDetails = new eps_bank_transfer\TransferInitiatorDetails(
            $userID,
            $pin,
            $bic,
            $fullName,
            $iban,
            $orderNumber,
            intval($orderTotal),
            $transferMsgDetails
        );

        $transferInitiatorDetails->RemittanceIdentifier = $orderNumber;
        $transferInitiatorDetails->SetExpirationMinutes(60);
        
        foreach ($items as $item) 
        {
            $article = new eps_bank_transfer\WebshopArticle(
                $item["articlename"],
                $item["quantity"],
                intval($item["price"]*100)
            );
            
            $transferInitiatorDetails->WebshopArticles[] = $article;
        }
        
        //Send TransferInitiatorDetails to Scheme Operator
        $soCommunicator = new eps_bank_transfer\SoCommunicator();
        $plain = $soCommunicator->SendTransferInitiatorDetails($transferInitiatorDetails, $targetUrl);

        $xml = new \SimpleXMLElement($plain);
        $soAnswer = $xml->children(eps_bank_transfer\XMLNS_epsp);
        $errorDetails = $soAnswer->BankResponseDetails->ErrorDetails;
 
        if (('' . $errorDetails->ErrorCode) != '000')
        {
            echo "error";
            var_dump($errorDetails); die;
        }
        else
        {
            $redirectUrl = $soAnswer->BankResponseDetails->ClientRedirectUrl->__toString();
            $this->redirect($redirectUrl);
        }
    }
}
