<?php

namespace SwagPaymentEps;

use Shopware\Components\Plugin;
use Shopware\Components\Plugin\Context\ActivateContext;
use Shopware\Components\Plugin\Context\DeactivateContext;
use Shopware\Components\Plugin\Context\InstallContext;
use Shopware\Components\Plugin\Context\UninstallContext;
use Shopware\Models\Payment\Payment;

class SwagPaymentEps extends Plugin
{
    /**
     * @param InstallContext $context
     */
     
    public function install(InstallContext $context)
    {
        /** @var \Shopware\Components\Plugin\PaymentInstaller $installer */
        $installer = $this->container->get('shopware.plugin_payment_installer');

        /* Prikazuje plaćanje Checkout-u  */
        $options = [
            'name' => 'Eps_payment_invoice',
            'description' => 'EPS Überweisung',
            'action' => 'PaymentEps',
            'active' => 0,
            'position' => 0,
            'additionalDescription' =>
                '<img src="custom/plugins/SwagPaymentEps/eps.png"/>'
                . '<div id="payment_desc">'
                . ''
                . '</div>'
        ];

        $installer->createOrUpdate($context->getPlugin(), $options);

        /* Prikazuje plaćanje Checkout-u  */
        $options = [
            'name' => 'Eps_payment_cc',
            'description' => 'EPS Überweisung',
            'action' => 'PaymentEps',
            'active' => 1,
            'position' => 0,
            'additionalDescription' =>
                '<img src="custom/plugins/SwagPaymentEps/eps.png"/>'
                . '<div id="payment_desc">'
                . ''
                . '</div>'
        ];

        $installer->createOrUpdate($context->getPlugin(), $options);
    }

    /**
     * @param UninstallContext $context
     */
    public function uninstall(UninstallContext $context)
    {
        $this->setActiveFlag($context->getPlugin()->getPayments(), false);
        $context->scheduleClearCache(UninstallContext::CACHE_LIST_ALL);
    }

    /**
     * @param DeactivateContext $context
     */
    public function deactivate(DeactivateContext $context)
    {
       $this->setActiveFlag($context->getPlugin()->getPayments(), false);
    }

    /**
     * @param ActivateContext $context
     */
    public function activate(ActivateContext $context)
    {
        $this->setActiveFlag($context->getPlugin()->getPayments(), true);
    }

    /**
     * @param Payment[] $payments
     * @param $active bool
     */
    private function setActiveFlag($payments, $active)
    {
        $em = $this->container->get('models');
        foreach ($payments as $payment) 
        {
            $payment->setActive($active);
        }
        $em->flush();
    }
}

